Index: LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_condensation.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_condensation.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_condensation.f90	(revision 5609)
@@ -690,5 +824,15 @@
         !--diagnostic, and if the cloud size is increased, we add the new vapor to the
         !--cloud's vapor without condensing or sublimating ice crystals
-        qvapinclr_lim = ( ( cldfra(i) + clrfra_mix ) * qsat(i) - qcld(i) ) / clrfra_mix
+        IF ( ok_unadjusted_clouds .AND. .NOT. ok_warm_cloud ) THEN
+          qiceinmix = ( qcld(i) - qvc(i) ) / cldfra(i) / ( 1. + clrfra_mix / cldfra_mix )
+          tau_depsub = 1. / ( qiceinmix**(1./3.) * kappa_depsub )
+          qvapinmix_lim = qsat(i) - qiceinmix / ( 1. - EXP( - dtime / tau_depsub ) )
+          qvapinclr_lim = qvapinmix_lim * ( 1. + cldfra_mix / clrfra_mix ) &
+                        - qvc(i) / cldfra(i) * cldfra_mix / clrfra_mix
+        ELSE
+          !--NB. if tau_depsub = 0, we get the same result as above
+          qvapinclr_lim = qsat(i) * ( 1. + cldfra_mix / clrfra_mix ) &
+                        - qcld(i) / cldfra(i) * cldfra_mix / clrfra_mix
+        ENDIF
 
         IF ( qvapinclr_lim .LT. 0. ) THEN
@@ -696,5 +840,4 @@
           dcf_mix(i)  = clrfra_mix
           dqvc_mix(i) = clrfra_mix * qclr(i) / clrfra(i)
-          dqi_mix(i)  = 0.
         ELSE
           !--We then calculate the clear sky part where the humidity is lower than
@@ -704,23 +847,17 @@
           !--because the clear sky fraction can only be reduced by condensation.
           !--Thus the `pdf_xxx` variables are well defined.
-          pdf_x = gamma_cond(i) * qsat(i) / qsatl(i) * 100.
-          pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
+
+          rhl_clr = qclr(i) / clrfra(i) / qsatl(i) * 100.
+          pdf_loc = rhl_clr - pdf_scale(i) * pdf_gamma(i)
+          pdf_x = qvapinclr_lim / qsatl(i) * 100.
+          pdf_y = ( MAX( pdf_x - pdf_loc, 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
           pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-          pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
-          pdf_fra_above_nuc = EXP( - pdf_y ) * clrfra(i)
-          pdf_q_above_nuc = ( pdf_e3 * clrfra(i) &
-                          + pdf_loc(i) * pdf_fra_above_nuc ) * qsatl(i) / 100.
-
-          pdf_x = qvapinclr_lim / qsatl(i) * 100.
-          pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
-          pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-          pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
+          pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_gamma(i)
           pdf_fra_above_lim = EXP( - pdf_y ) * clrfra(i)
           pdf_q_above_lim = ( pdf_e3 * clrfra(i) &
-                          + pdf_loc(i) * pdf_fra_above_lim ) * qsatl(i) / 100.
+                          + pdf_loc * pdf_fra_above_lim ) * qsatl(i) / 100.
 
           pdf_fra_below_lim = clrfra(i) - pdf_fra_above_lim
-          pdf_fra_above_lim = pdf_fra_above_lim - pdf_fra_above_nuc
-          pdf_q_above_lim = pdf_q_above_lim - pdf_q_above_nuc
+          pdf_q_below_lim = qclr(i) - pdf_q_above_lim
 
           !--sigma_mix is the ratio of the surroundings of the clouds where mixing
@@ -733,23 +870,15 @@
             dcf_mix(i)  = clrfra_mix * sigma_mix
             dqvc_mix(i) = clrfra_mix * sigma_mix * pdf_q_above_lim / pdf_fra_above_lim
-            dqi_mix(i)  = 0.
           ENDIF
 
           IF ( pdf_fra_below_lim .GT. eps ) THEN
-            dcf_mix(i)  = dcf_mix(i)  - cldfra(i) * ( 1. - sigma_mix )
-            dqvc_mix(i) = dqvc_mix(i) - cldfra(i) * ( 1. - sigma_mix ) &
-                                                  * qvc(i) / cldfra(i)
-            dqi_mix(i)  = dqi_mix(i)  - cldfra(i) * ( 1. - sigma_mix ) &
-                                                  * ( qcld(i) - qvc(i) ) / cldfra(i)
+            dcf_mix(i)  = dcf_mix(i)  - cldfra_mix * ( 1. - sigma_mix )
+            dqvc_mix(i) = dqvc_mix(i) - cldfra_mix * ( 1. - sigma_mix ) &
+                                      * qvc(i) / cldfra(i)
+            dqi_mix(i)  = dqi_mix(i)  - cldfra_mix * ( 1. - sigma_mix ) &
+                                      * ( qcld(i) - qvc(i) ) / cldfra(i)
           ENDIF
+
         ENDIF
-
-        !--Add tendencies
-        cldfra(i)  = cldfra(i) + dcf_mix(i)
-        qcld(i)    = qcld(i) + dqvc_mix(i) + dqi_mix(i)
-        qvc(i)     = qvc(i) + dqvc_mix(i)
-        clrfra(i)  = clrfra(i) - dcf_mix(i)
-        qclr(i)    = qclr(i) - dqvc_mix(i) - dqi_mix(i)
-      
       ENDIF ! ( cldfra(i) .GT. eps ) .AND. ( clrfra(i) .GT. eps )
 
@@ -812,4 +941,8 @@
         clrfra_mix = N_cld_mix * RPI / cell_area(i) &
                    * ( a_mix * ( 1. + bovera ) * L_mix + L_mix**2 )
+        !--The fraction of clear sky mixed is
+        !-- N_cld_mix * ( a * b - (a - L_mix) * (b - L_mix) ) * RPI / cell_area
+        cldfra_mix = N_cld_mix * RPI / cell_area(i) &
+                   * ( a_mix * ( 1. + bovera ) * L_mix - L_mix**2 )
         
         
@@ -823,5 +956,5 @@
         !--With this, the clouds increase in size along b only, by a factor
         !--L_shear * SQRT(2.) / 2. (to account for the 45 degrees orientation of the wind)
-        L_shear = coef_shear_contrails * shear(i) * dz(i) * dtime
+        L_shear = coef_shear_contrails * shear(i) * dz * dtime
         !--therefore, the fraction of clear sky mixed is
         !-- N_cld_mix * ( a * (b + L_shear * SQRT(2.) / 2.) - a * b ) * RPI / 2. / cell_area
@@ -835,9 +968,11 @@
         !--mixed clouds are different.
         clrfra_mix = clrfra_mix + shear_fra
+        cldfra_mix = cldfra_mix + shear_fra
         
         
         !-- PART 3 - CALCULATION OF THE MIXING PROPERTIES
         
-        clrfra_mix = MIN( clrfra_mix, clrfra(i) )
+        clrfra_mix = MAX(eps, MIN(clrfra(i), clrfra_mix))
+        cldfra_mix = MAX(eps, MIN(cldfra(i), cldfra_mix))
         
         !--We compute the limit vapor in clear sky where the mixed cloud could not
@@ -847,5 +982,6 @@
         !--diagnostic, and if the cloud size is increased, we add the new vapor to the
         !--cloud's vapor without condensing or sublimating ice crystals
-        qvapinclr_lim = ( ( contfra(i) + clrfra_mix ) * qsat(i) - qcont(i) ) / clrfra_mix
+        qvapinclr_lim = qsat(i) * ( 1. + cldfra_mix / clrfra_mix ) &
+                      - qcont(i) / contfra(i) * cldfra_mix / clrfra_mix
 
         IF ( qvapinclr_lim .LT. 0. ) THEN
@@ -853,5 +989,4 @@
           dcfa_mix(i) = clrfra_mix
           dqta_mix(i) = clrfra_mix * qclr(i) / clrfra(i)
-          dqia_mix(i) = 0.
         ELSE
           !--We then calculate the clear sky part where the humidity is lower than
@@ -861,23 +996,16 @@
           !--because the clear sky fraction can only be reduced by condensation.
           !--Thus the `pdf_xxx` variables are well defined.
-          pdf_x = gamma_cond(i) * qsat(i) / qsatl(i) * 100.
-          pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
+
+          rhl_clr = qclr(i) / clrfra(i) / qsatl(i) * 100.
+          pdf_loc = rhl_clr - pdf_scale(i) * pdf_gamma(i)
+          pdf_x = qvapinclr_lim / qsatl(i) * 100.
+          pdf_y = ( MAX( pdf_x - pdf_loc, 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
           pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-          pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
-          pdf_fra_above_nuc = EXP( - pdf_y ) * clrfra(i)
-          pdf_q_above_nuc = ( pdf_e3 * clrfra(i) &
-                          + pdf_loc(i) * pdf_fra_above_nuc ) * qsatl(i) / 100.
-
-          pdf_x = qvapinclr_lim / qsatl(i) * 100.
-          pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
-          pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-          pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
+          pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_gamma(i)
           pdf_fra_above_lim = EXP( - pdf_y ) * clrfra(i)
           pdf_q_above_lim = ( pdf_e3 * clrfra(i) &
-                          + pdf_loc(i) * pdf_fra_above_lim ) * qsatl(i) / 100.
+                          + pdf_loc * pdf_fra_above_lim ) * qsatl(i) / 100.
 
           pdf_fra_below_lim = clrfra(i) - pdf_fra_above_lim
-          pdf_fra_above_lim = pdf_fra_above_lim - pdf_fra_above_nuc
-          pdf_q_above_lim = pdf_q_above_lim - pdf_q_above_nuc
 
           !--sigma_mix is the ratio of the surroundings of the clouds where mixing
@@ -893,14 +1021,27 @@
             dcfa_mix(i) = clrfra_mix * sigma_mix
             dqta_mix(i) = clrfra_mix * sigma_mix * pdf_q_above_lim / pdf_fra_above_lim
-            dqia_mix(i) = 0.
           ENDIF
 
           IF ( pdf_fra_below_lim .GT. eps ) THEN
-            dcfa_mix(i) = dcfa_mix(i) - contfra(i) * ( 1. - sigma_mix )
-            dqta_mix(i) = dqta_mix(i) - contfra(i) * ( 1. - sigma_mix ) &
-                                      * qcont(i) / contfra(i)
-            dqia_mix(i) = dqia_mix(i) - contfra(i) * ( 1. - sigma_mix ) &
-                                      * ( qcont(i) / contfra(i) - qsat(i) )
+            qvapincld = qcont(i) / contfra(i)
+            qiceincld = qvapincld - qsat(i)
+            dcfa_mix(i) = dcfa_mix(i) - cldfra_mix * ( 1. - sigma_mix )
+            dqta_mix(i) = dqta_mix(i) - cldfra_mix * ( 1. - sigma_mix ) * qvapincld
+            dqia_mix(i) = dqia_mix(i) - cldfra_mix * ( 1. - sigma_mix ) * qiceincld
           ENDIF
+
+        ENDIF
+      ENDIF ! ( contfra(i) .GT. eps ) .AND. ( clrfra(i) .GT.  eps )
+
+      IF ( contfra(i) .GT. eps ) THEN
+        !--We balance the mixing tendencies between the different cloud classes
+        mixed_fraction = dcf_mix(i) + dcfa_mix(i)
+        IF ( mixed_fraction .GT. clrfra(i) ) THEN
+          mixed_fraction = clrfra(i) / mixed_fraction
+          dcf_mix(i)  = dcf_mix(i)  * mixed_fraction
+          dqvc_mix(i) = dqvc_mix(i) * mixed_fraction
+          dqi_mix(i)  = dqi_mix(i)  * mixed_fraction
+          dcfa_mix(i) = dcfa_mix(i) * mixed_fraction
+          dqta_mix(i) = dqta_mix(i) * mixed_fraction
         ENDIF
 
@@ -910,6 +1051,81 @@
         clrfra(i)  = clrfra(i) - dcfa_mix(i)
         qclr(i)    = qclr(i) - dqta_mix(i)
-
-      ENDIF ! ( contfra(i) .GT. eps ) .AND. ( clrfra(i) .GT.  eps )
+      ENDIF
+
+      !--Add tendencies
+      cldfra(i)  = cldfra(i) + dcf_mix(i)
+      qcld(i)    = qcld(i) + dqvc_mix(i) + dqi_mix(i)
+      qvc(i)     = qvc(i) + dqvc_mix(i)
+      clrfra(i)  = clrfra(i) - dcf_mix(i)
+      qclr(i)    = qclr(i) - dqvc_mix(i) - dqi_mix(i)
+
+      !--If there is a contrail induced cirrus, we restore it
+      perscontfra(i) = perscontfra_ratio * cldfra(i)
+
+
+      !---------------------------------------
+      !--         ICE SEDIMENTATION         --
+      !---------------------------------------
+      !
+      !--If ice supersaturation is activated, the cloud properties are prognostic.
+      !--The falling ice is then considered a new cloud in the gridbox.
+      !--BEWARE with this parameterisation, we can create a new cloud with a much
+      !--different ice water content and water vapor content than the existing cloud
+      !--(if it exists). This implies than unphysical fluxes of ice and vapor
+      !--occur between the existing cloud and the newly formed cloud (from sedimentation).
+      !--Note also that currently, the precipitation scheme assume a maximum
+      !--random overlap, meaning that the new formed clouds will not be affected
+      !--by vertical wind shear.
+      !
+      IF ( icesed_flux(i) .GT. 0. ) THEN
+
+        clrfra_sed = MIN(clrfra(i), cldfra_above(i) - cldfra(i))
+
+        IF ( ( clrfra_sed .GT. eps ) .AND. ( clrfra(i) .GT. eps ) ) THEN
+
+          qiceincld = qice_sedim(i) / cldfra_above(i)
+          IF ( ok_unadjusted_clouds .AND. .NOT. ok_warm_cloud ) THEN
+            tau_depsub = 1. / ( qiceincld**(1./3.) * kappa_depsub )
+            qvapinclr_lim = qsat(i) - qiceincld / ( 1. - EXP( - dtime / tau_depsub ) )
+          ELSE
+            qvapinclr_lim = qsat(i) - qiceincld
+          ENDIF
+
+          rhl_clr = qclr(i) / clrfra(i) / qsatl(i) * 100.
+          pdf_loc = rhl_clr - pdf_scale(i) * pdf_gamma(i)
+          pdf_x = qvapinclr_lim / qsatl(i) * 100.
+          pdf_y = ( MAX( pdf_x - pdf_loc, 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
+          pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
+          pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_gamma(i)
+          pdf_fra_above_lim = EXP( - pdf_y ) * clrfra(i)
+          pdf_q_above_lim = ( pdf_e3 * clrfra(i) &
+                          + pdf_loc * pdf_fra_above_lim ) * qsatl(i) / 100.
+
+          IF ( pdf_fra_above_lim .GT. eps ) THEN
+            dcf_sed(i)  = clrfra_sed * pdf_fra_above_lim / clrfra(i)
+            dqvc_sed(i) = dcf_sed(i) * pdf_q_above_lim / pdf_fra_above_lim
+            !--We include the sedimentated ice:
+            dqi_sed(i)  = qiceincld &    !--We include the sedimentated ice:
+                        * ( dcf_sed(i) & !--the part that falls in the newly formed cloud and
+                          + cldfra(i) )  !--the part that falls in the existing cloud
+                        
+          ENDIF
+
+        ELSE
+
+          dqi_sed(i) = qice_sedim(i)
+
+        ENDIF ! clrfra(i) .GT. eps
+
+        !--Add tendencies
+        cldfra(i)  = MIN(1., cldfra(i) + dcf_sed(i))
+        qcld(i)    = qcld(i) + dqvc_sed(i) + dqi_sed(i)
+        qvc(i)     = qvc(i) + dqvc_sed(i)
+        clrfra(i)  = MAX(0., clrfra(i) - dcf_sed(i))
+        !--We re-include sublimated sedimentated ice into clear sky water vapor
+        qclr(i)    = qclr(i) - dqvc_sed(i) + qice_sedim(i) - dqi_sed(i)
+
+      ENDIF ! qice_sedim(i) .GT. 0.
+
 
       !--We put back contrails in the clouds class
@@ -919,38 +1135,17 @@
 
 
-      !--Diagnostics
-      dcf_sub(i)  = dcf_sub(i)  / dtime
-      dcf_con(i)  = dcf_con(i)  / dtime 
-      dcf_mix(i)  = dcf_mix(i)  / dtime 
-      dqi_adj(i)  = dqi_adj(i)  / dtime 
-      dqi_sub(i)  = dqi_sub(i)  / dtime 
-      dqi_con(i)  = dqi_con(i)  / dtime 
-      dqi_mix(i)  = dqi_mix(i)  / dtime 
-      dqvc_adj(i) = dqvc_adj(i) / dtime
-      dqvc_sub(i) = dqvc_sub(i) / dtime
-      dqvc_con(i) = dqvc_con(i) / dtime
-      dqvc_mix(i) = dqvc_mix(i) / dtime
-        
       !--Diagnose ISSRs
       IF ( clrfra(i) .GT. eps ) THEN
-        !--We then calculate the part that is greater than qsat
-        !--and lower than gamma_cond * qsat, which is the ice supersaturated region
-        pdf_x = gamma_cond(i) * qsat(i) / qsatl(i) * 100.
-        pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
+        rhl_clr = qclr(i) / clrfra(i) / qsatl(i) * 100.
+        pdf_loc = rhl_clr - pdf_scale(i) * pdf_gamma(i)
+        pdf_x = qsat(i) / qsatl(i) * 100.
+        pdf_y = ( MAX( pdf_x - pdf_loc, 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
         pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-        pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
-        pdf_fra_above_nuc = EXP( - pdf_y ) * clrfra(i)
-        pdf_q_above_nuc = ( pdf_e3 * clrfra(i) &
-                        + pdf_loc(i) * pdf_fra_above_nuc ) * qsatl(i) / 100.
-
-        pdf_x = qsat(i) / qsatl(i) * 100.
-        pdf_y = ( MAX( pdf_x - pdf_loc(i), 0. ) / pdf_scale(i) ) ** pdf_alpha(i)
-        pdf_e3 = GAMMAINC ( 1. + 1. / pdf_alpha(i) , pdf_y )
-        pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_e2
+        pdf_e3 = pdf_scale(i) * ( 1. - pdf_e3 ) * pdf_gamma(i)
         issrfra(i) = EXP( - pdf_y ) * clrfra(i)
-        qissr(i) = ( pdf_e3 * clrfra(i) + pdf_loc(i) * issrfra(i) ) * qsatl(i) / 100.
-
-        issrfra(i) = issrfra(i) - pdf_fra_above_nuc
-        qissr(i) = qissr(i) - pdf_q_above_nuc
+        qissr(i) = ( pdf_e3 * clrfra(i) + pdf_loc * issrfra(i) ) * qsatl(i) / 100.
+      ELSE
+        issrfra(i) = 0.
+        qissr(i) = 0.
       ENDIF
 
@@ -969,4 +1164,20 @@
       ENDIF ! cldfra .LT. eps
 
+      !--Diagnostics
+      dcf_sub(i)  = dcf_sub(i)  / dtime
+      dcf_con(i)  = dcf_con(i)  / dtime 
+      dcf_mix(i)  = dcf_mix(i)  / dtime
+      dcf_sed(i)  = dcf_sed(i)  / dtime 
+      dqi_adj(i)  = dqi_adj(i)  / dtime 
+      dqi_sub(i)  = dqi_sub(i)  / dtime 
+      dqi_con(i)  = dqi_con(i)  / dtime 
+      dqi_mix(i)  = dqi_mix(i)  / dtime
+      dqi_sed(i)  = dqi_sed(i)  / dtime 
+      dqvc_adj(i) = dqvc_adj(i) / dtime
+      dqvc_sub(i) = dqvc_sub(i) / dtime
+      dqvc_con(i) = dqvc_con(i) / dtime
+      dqvc_mix(i) = dqvc_mix(i) / dtime
+      dqvc_sed(i) = dqvc_sed(i) / dtime
+
     ENDIF ! ( temp(i) .GT. temp_nowater ) .AND. .NOT. ok_weibull_warm_clouds
 
@@ -983,23 +1194,39 @@
   CALL contrails_formation( &
       klon, dtime, pplay, temp, qsat, qsatl, gamma_cond, &
-      flight_dist, clrfra, pdf_loc, pdf_scale, pdf_alpha, keepgoing, &
+      flight_dist, clrfra, qclr, pdf_scale, pdf_alpha, pdf_gamma, &
+      keepgoing, pt_pron_clds, &
       Tcritcont, qcritcont, potcontfraP, potcontfraNP, &
       dcfa_ini, dqia_ini, dqta_ini)
 
   DO i = 1, klon
-    IF ( keepgoing(i) .AND. ( temp(i) .LE. temp_nowater ) ) THEN
+    IF ( keepgoing(i) .AND. pt_pron_clds(i) ) THEN
 
       !--Convert existing contrail fraction into "natural" cirrus cloud fraction
-      dcfa_cir(i) = contfra(i) * ( EXP( - dtime / linear_contrails_lifetime ) - 1. )
-      dqta_cir(i) = qcont(i)   * ( EXP( - dtime / linear_contrails_lifetime ) - 1. )
+      IF ( cldfra(i) .GE. ( 1. - cfcon(i) - eps ) ) THEN
+        contrails_conversion_factor = 1.
+      ELSE
+        contrails_conversion_factor = ( 1. - &
+            !--First, the linear contrails are continuously degraded in induced cirrus
+            EXP( - dtime / linear_contrails_lifetime ) &
+            !--Second, if the cloud fills the entire gridbox, the linear contrails
+            !--cannot exist. The exponent is set so that this only happens for
+            !--very cloudy gridboxes
+            * ( 1. - cldfra(i) / ( 1. - cfcon(i) ) )**0.1 )
+      ENDIF
+      dcfa_cir(i) = - contrails_conversion_factor * contfra(i)
+      dqta_cir(i) = - contrails_conversion_factor * qcont(i)
 
       !--Add tendencies
       issrfra(i) = MAX(0., issrfra(i) - dcfa_ini(i))
       qissr(i)   = MAX(0., qissr(i) - dqta_ini(i))
-      cldfra(i)  = MAX(0., MIN(1. - cldfracv(i), cldfra(i) + dcfa_ini(i)))
-      qcld(i)    = MAX(0., MIN(qtot(i), qcld(i) + dqta_ini(i)))
+      clrfra(i)  = MAX(0., clrfra(i) - dcfa_ini(i))
+      qclr(i)    = MAX(0., qclr(i) - dqta_ini(i))
+
+      cldfra(i)  = MAX(0., MIN(1. - cfcon(i), cldfra(i) + dcfa_ini(i)))
+      qcld(i)    = MAX(0., MIN(qtot_in(i), qcld(i) + dqta_ini(i)))
       qvc(i)     = MAX(0., MIN(qcld(i), qvc(i) + dcfa_ini(i) * qsat(i)))
       contfra(i) = MAX(0., MIN(cldfra(i), contfra(i) + dcfa_cir(i) + dcfa_ini(i)))
       qcont(i)   = MAX(0., MIN(qcld(i), qcont(i) + dqta_cir(i) + dqta_ini(i)))
+      perscontfra(i) = perscontfra(i) - dcfa_cir(i)
 
       !--Diagnostics
@@ -1024,6 +1251,8 @@
         cldfra(i) = 0.
         contfra(i)= 0.
+        perscontfra(i) = 0.
         qcld(i)   = 0.
         qvc(i)    = 0.
+        qcont(i)  = 0.
         qincld(i) = qsat(i)
       ELSE
@@ -1036,4 +1265,6 @@
       ENDIF
 
+      IF ( perscontfra(i) .LT. eps ) perscontfra(i) = 0.
+
     ENDIF ! keepgoing
   ENDDO
@@ -1044,146 +1275,3 @@
 !**********************************************************************************
 
-FUNCTION QVAPINCLD_DEPSUB( &
-    qvapincld, qiceincld, temp, qsat, pplay, dtime)
-
-USE lmdz_lscp_ini, ONLY: RV, RLSTT, RTT, RD, EPS_W
-USE lmdz_lscp_ini, ONLY: depo_coef_cirrus, capa_cond_cirrus, rho_ice
-USE lmdz_lscp_ini, ONLY: eps
-
-IMPLICIT NONE
-
-! inputs
-REAL :: qvapincld     ! 
-REAL :: qiceincld     ! 
-REAL :: temp          ! 
-REAL :: qsat          ! 
-REAL :: pplay         ! 
-REAL :: dtime         ! time step [s]
-! outpu
-REAL :: qvapincld_depsub
-
-!
-! local
-REAL :: pres_sat, rho, kappa
-REAL :: air_thermal_conduct, water_vapor_diff
-REAL :: iwc
-REAL :: iwc_log_inf100, iwc_log_sup100
-REAL :: iwc_inf100, alpha_inf100, coef_inf100
-REAL :: mu_sup100, sigma_sup100, coef_sup100
-REAL :: Dm_ice, rm_ice
-
-!--If ok_unadjusted_clouds is set to TRUE, then the saturation adjustment
-!--hypothesis is lost, and the vapor in the cloud is purely prognostic.
-!
-!--The deposition equation is
-!-- dmi/dt = alpha*4pi*C*Svi / ( R_v*T/esi/Dv + Ls/ka/T * (Ls/R_v/T - 1) )
-!--from Lohmann et al. (2016), where
-!--alpha is the deposition coefficient [-]
-!--mi is the mass of one ice crystal [kg]
-!--C is the capacitance of an ice crystal [m]
-!--Svi is the supersaturation ratio equal to (qvc - qsat)/qsat [-]
-!--R_v is the specific gas constant for humid air [J/kg/K]
-!--T is the temperature [K]
-!--esi is the saturation pressure w.r.t. ice [Pa]
-!--Dv is the diffusivity of water vapor [m2/s]
-!--Ls is the specific latent heat of sublimation [J/kg/K]
-!--ka is the thermal conductivity of dry air [J/m/s/K]
-!
-!--alpha is a coefficient to take into account the fact that during deposition, a water
-!--molecule cannot join the crystal from everywhere, it must do so that the crystal stays
-!--coherent (with the same structure). It has no impact for sublimation.
-!--We fix alpha = depo_coef_cirrus (=0.5 by default following Lohmann et al. (2016))
-!--during deposition, and alpha = 1. during sublimation.
-!--The capacitance of the ice crystals is proportional to a parameter capa_cond_cirrus
-!-- C = capa_cond_cirrus * rm_ice
-!
-!--We have qice = Nice * mi, where Nice is the ice crystal
-!--number concentration per kg of moist air
-!--HYPOTHESIS 1: the ice crystals are spherical, therefore
-!-- mi = 4/3 * pi * rm_ice**3 * rho_ice
-!--HYPOTHESIS 2: the ice crystals are monodisperse with the
-!--initial radius rm_ice_0.
-!--NB. this is notably different than the assumption
-!--of a distributed qice in the cloud made in the sublimation process;
-!--should it be consistent?
-!
-!--As the deposition process does not create new ice crystals,
-!--and because we assume a same rm_ice value for all crystals
-!--therefore the sublimation process does not destroy ice crystals
-!--(or, in a limit case, it destroys all ice crystals), then
-!--Nice is a constant during the sublimation/deposition process.
-!-- dmi = dqi, et Nice = qi_0 / ( 4/3 RPI rm_ice_0**3 rho_ice )
-!
-!--The deposition equation then reads:
-!-- dqi/dt = alpha*4pi*capa_cond_cirrus*rm_ice*(qvc-qsat)/qsat / ( R_v*T/esi/Dv + Ls/ka/T * (Ls/R_v/T - 1) ) * Nice
-!-- dqi/dt = alpha*4pi*capa_cond_cirrus* (qi / qi_0)**(1/3) *rm_ice_0*(qvc-qsat)/qsat &
-!--             / ( R_v*T/esi/Dv + Ls/ka/T * (Ls*R_v/T - 1) ) &
-!--                         * qi_0 / ( 4/3 RPI rm_ice_0**3 rho_ice )
-!-- dqi/dt = qi**(1/3) * (qvc - qsat) * qi_0**(2/3) &
-!--  *alpha/qsat*capa_cond_cirrus/ (R_v*T/esi/Dv + Ls/ka/T*(Ls*R_v/T - 1)) / ( 1/3 rm_ice_0**2 rho_ice )
-!--and we have
-!-- dqvc/dt = - qi**(1/3) * (qvc - qsat) / kappa * alpha * qi_0**(2/3) / rm_ice_0**2
-!-- dqi/dt  =   qi**(1/3) * (qvc - qsat) / kappa * alpha * qi_0**(2/3) / rm_ice_0**2
-!--where kappa = 1/3*rho_ice/capa_cond_cirrus*qsat*(R_v*T/esi/Dv + Ls/ka/T*(Ls/R_v/T - 1))
-!
-!--This system of equations can be resolved with an exact
-!--explicit numerical integration, having one variable resolved
-!--explicitly, the other exactly. The exactly resolved variable is
-!--the one decreasing, so it is qvc if the process is
-!--condensation, qi if it is sublimation.
-!
-!--kappa is computed as an initialisation constant, as it depends only
-!--on temperature and other pre-computed values
-pres_sat = qsat / ( EPS_W + ( 1. - EPS_W ) * qsat ) * pplay
-!--This formula for air thermal conductivity comes from Beard and Pruppacher (1971)
-air_thermal_conduct = ( 5.69 + 0.017 * ( temp - RTT ) ) * 1.e-3 * 4.184
-!--This formula for water vapor diffusivity comes from Hall and Pruppacher (1976)
-water_vapor_diff = 0.211 * ( temp / RTT )**1.94 * ( 101325. / pplay ) * 1.e-4
-kappa = 1. / 3. * rho_ice / capa_cond_cirrus * qsat &
-      * ( RV * temp / water_vapor_diff / pres_sat &
-        + RLSTT / air_thermal_conduct / temp * ( RLSTT / RV / temp - 1. ) )
-!--NB. the greater kappa, the lower the efficiency of the deposition/sublimation process
-
-!--Dry density [kg/m3]
-rho = pplay / temp / RD
-
-!--Here, the initial vapor in the cloud is qvapincld, and we compute
-!--the new vapor qvapincld_new
-
-!--rm_ice formula from McFarquhar and Heymsfield (1997)
-iwc = qiceincld * rho * 1e3
-iwc_inf100 = MIN(iwc, 0.252 * iwc**0.837)
-iwc_log_inf100 = LOG10( MAX(eps, iwc_inf100) )
-iwc_log_sup100 = LOG10( MAX(eps, iwc - iwc_inf100) )
-
-alpha_inf100 = - 4.99E-3 - 0.0494 * iwc_log_inf100
-coef_inf100 = iwc_inf100 * alpha_inf100**3 / 120.
-
-mu_sup100 = ( 5.2 + 0.0013 * ( temp - RTT ) ) &
-          + ( 0.026 - 1.2E-3 * ( temp - RTT ) ) * iwc_log_sup100
-sigma_sup100 = ( 0.47 + 2.1E-3 * ( temp - RTT ) ) &
-             + ( 0.018 - 2.1E-4 * ( temp - RTT ) ) * iwc_log_sup100
-coef_sup100 = ( iwc - iwc_inf100 ) / EXP( 3. * mu_sup100 + 4.5 * sigma_sup100**2 )
-
-Dm_ice = ( 2. / alpha_inf100 * coef_inf100 + EXP( mu_sup100 + 0.5 * sigma_sup100**2 ) &
-       * coef_sup100 ) / ( coef_inf100 + coef_sup100 )
-rm_ice = Dm_ice / 2. * 1.E-6
-
-IF ( qvapincld .GE. qsat ) THEN
-  !--If the cloud is initially supersaturated
-  !--Exact explicit integration (qvc exact, qice explicit)
-  qvapincld_depsub = qsat + ( qvapincld - qsat ) &
-                   * EXP( - depo_coef_cirrus * dtime * qiceincld / kappa / rm_ice**2 )
-ELSE
-  !--If the cloud is initially subsaturated
-  !--Exact explicit integration (qvc exact, qice explicit)
-  !--Same but depo_coef_cirrus = 1
-  qvapincld_depsub = qsat + ( qvapincld - qsat ) &
-                   * EXP( - dtime * qiceincld / kappa / rm_ice**2 )
-  IF ( qvapincld_depsub .GE. ( qvapincld + qiceincld ) ) &
-                   qvapincld_depsub = 0.
-ENDIF ! qvapincld .GT. qsat
-
-END FUNCTION QVAPINCLD_DEPSUB
-
 END MODULE lmdz_lscp_condensation
Index: LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_ini.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_ini.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp_ini.f90	(revision 5609)
@@ -162,4 +162,7 @@
   !$OMP THREADPRIVATE(ok_weibull_warm_clouds)
 
+  REAL, SAVE, PROTECTED :: ffallv_issr                       ! tuning coefficient crystal fall velocity, cirrus clouds (with ISSR)
+  !$OMP THREADPRIVATE(ffallv_issr)
+
   REAL, SAVE, PROTECTED :: depo_coef_cirrus=.7               ! [-] deposition coefficient for growth of ice crystals in cirrus clouds
   !$OMP THREADPRIVATE(depo_coef_cirrus)
@@ -168,8 +171,8 @@
   !$OMP THREADPRIVATE(capa_cond_cirrus)
 
-  REAL, SAVE, PROTECTED :: std_subl_pdf_lscp=2.              ! [%] standard deviation of the gaussian distribution of water inside ice clouds
-  !$OMP THREADPRIVATE(std_subl_pdf_lscp)
-  
-  REAL, SAVE, PROTECTED :: beta_pdf_lscp=1.E-3               ! [SI] tuning coefficient for the standard deviation of the PDF of water vapor in the clear sky region
+  REAL, SAVE, PROTECTED :: mu_subl_pdf_lscp=1./3.            ! [-] factor for the ice distribution inside cirrus clouds
+  !$OMP THREADPRIVATE(mu_subl_pdf_lscp)
+  
+  REAL, SAVE, PROTECTED :: beta_pdf_lscp=8.75E-4             ! [SI] tuning coefficient for the standard deviation of the PDF of water vapor in the clear sky region
   !$OMP THREADPRIVATE(beta_pdf_lscp)
   
@@ -192,5 +195,5 @@
   !$OMP THREADPRIVATE(b_homofreez)
 
-  REAL, SAVE, PROTECTED :: delta_hetfreez=1.                 ! [-] value between 0 and 1 to simulate for heterogeneous freezing.
+  REAL, SAVE, PROTECTED :: delta_hetfreez=0.85               ! [-] value between 0 and 1 to simulate for heterogeneous freezing.
   !$OMP THREADPRIVATE(delta_hetfreez)
   
@@ -344,6 +347,6 @@
   !$OMP THREADPRIVATE(ok_ice_sedim)
 
-  REAL, SAVE, PROTECTED :: ice_fallspeed_sedim=0.1          ! Ice fallspeed velocity for sedimentation [m/s]
-  !$OMP THREADPRIVATE(ice_fallspeed_sedim)
+  REAL, SAVE, PROTECTED :: fallice_sedim=1.                 ! Tuning factor for ice fallspeed velocity for sedimentation [-]
+  !$OMP THREADPRIVATE(fallice_sedim)
   !--End of the parameters for poprecip
 
@@ -466,11 +469,13 @@
     CALL getin_p('snow_fallspeed_cld',snow_fallspeed_cld)
     CALL getin_p('ok_ice_sedim',ok_ice_sedim)
-    CALL getin_p('ice_fallspeed_sedim',ice_fallspeed_sedim)
+    CALL getin_p('fallice_sedim',fallice_sedim)
     ! for condensation and ice supersaturation
     CALL getin_p('ok_unadjusted_clouds',ok_unadjusted_clouds)
     CALL getin_p('ok_weibull_warm_clouds',ok_weibull_warm_clouds)
+    ffallv_issr=ffallv_lsc
+    CALL getin_p('ffallv_issr',ffallv_issr)
     CALL getin_p('depo_coef_cirrus',depo_coef_cirrus)
     CALL getin_p('capa_cond_cirrus',capa_cond_cirrus)
-    CALL getin_p('std_subl_pdf_lscp',std_subl_pdf_lscp)
+    CALL getin_p('mu_subl_pdf_lscp',mu_subl_pdf_lscp)
     CALL getin_p('beta_pdf_lscp',beta_pdf_lscp)
     CALL getin_p('temp_thresh_pdf_lscp',temp_thresh_pdf_lscp)
@@ -562,12 +567,13 @@
     WRITE(lunout,*) 'lscp_ini, snow_fallspeed_cld:', snow_fallspeed_cld
     WRITE(lunout,*) 'lscp_ini, ok_ice_sedim:', ok_ice_sedim
-    WRITE(lunout,*) 'lscp_ini, ice_fallspeed_sedim:', ice_fallspeed_sedim
+    WRITE(lunout,*) 'lscp_ini, fallice_sedim:', fallice_sedim
     ! for condensation and ice supersaturation
     WRITE(lunout,*) 'lscp_ini, ok_ice_supersat:', ok_ice_supersat
     WRITE(lunout,*) 'lscp_ini, ok_unadjusted_clouds:', ok_unadjusted_clouds
     WRITE(lunout,*) 'lscp_ini, ok_weibull_warm_clouds:', ok_weibull_warm_clouds
+    WRITE(lunout,*) 'lscp_ini, ffallv_issr', ffallv_issr
     WRITE(lunout,*) 'lscp_ini, depo_coef_cirrus:', depo_coef_cirrus
     WRITE(lunout,*) 'lscp_ini, capa_cond_cirrus:', capa_cond_cirrus
-    WRITE(lunout,*) 'lscp_ini, std_subl_pdf_lscp:', std_subl_pdf_lscp
+    WRITE(lunout,*) 'lscp_ini, mu_subl_pdf_lscp:', mu_subl_pdf_lscp
     WRITE(lunout,*) 'lscp_ini, beta_pdf_lscp:', beta_pdf_lscp
     WRITE(lunout,*) 'lscp_ini, temp_thresh_pdf_lscp:', temp_thresh_pdf_lscp
